// Dec. 2013 - roadblock game - code by Emperor Katax - www.kataxco.com
// -----------------------------------------------------
//
// -----------------------------------------------------
window.onload = function () {
			var canvas = document.getElementById('canvas'),
			context = canvas.getContext('2d'),
			mouse = utils.captureMouse(canvas);
			touch = utils.captureTouch(canvas);
			// text font
			context.font = '40pt Arial';
			context.fillStyle = 'blue';
			// files
			var fileNames = new FileData();
			// add background maps
			var map_stage = 0;			// easy = 0 , medium = 1, hard = 2 
			var map_level = 0;			// map level number 0 - 2
			var map_level_buffer = 0;			// map level number 0 - 2
			var backGRmanager = new BackGRManager();
			backGRmanager.addImage(fileNames.getData("map", map_stage, map_level));	
			
			
			// add player
			var player = new Player(fileNames.getData("player"));
			// messages
			var msg = new MsgManager();
			msg.addImage(fileNames.getData("msg"));
			// control
			var gameSpeed_def = [.8, 1.4, 2];
			var gameSpeed_iterator = 0;
			var gameSpeed = gameSpeed_def[gameSpeed_iterator];				// set game speed - use: .8, 1.4 and 2
			backGRmanager.setGameSpeed(gameSpeed);		// apply game speed for background
			player.setGameSpeed(gameSpeed);						// apply game speed for player avatar
			var keyMap = new KeyMaps();								// key map for path finder
			var pathFinder = new PathFinderUnit(keyMap.getData(map_stage, map_level));		// pathfinder class
			
			var startGame = false;												// start game flag
			var gameOver = false;												// start game flag
			var gameOver_delay = false;								// delay on loading next map
			var game_nextLevel = false;								// next difficulty
			var game_end = false;												// end game
			
			var player_Xbuffer = 0;											// buffer current player x
			var player_Ybuffer = 0;											// buffer current player y
			// touch
			var isTouch = !!("undefined" != typeof document.documentElement.ontouchstart); // test - 24
			var player_Xbuffer_touch = 0;											// buffer current player x on touch
			var player_Ybuffer_touch = 0;											// buffer current player y on touch
			
			player.setplayerStartPoint(pathFinder.playerStartCoord_x, pathFinder.playerStartCoord_y);
			
			// Google Analytics tracking code
			var _gaq = _gaq || [];
			_gaq.push(['_setAccount', 'UA-27034712-1']);
			_gaq.push(['_trackPageview']);

			var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
			ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
			var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
			///////////////////////////////////////// mouse 
			canvas.addEventListener('mousedown', function () {
				startGame = true;
				if ( !touch.isPressed && !isTouch && !gameOver){
					player.setDestination(mouse.x, mouse.y);																		// send mouse coodination to player class
					backGRmanager.setDestination(mouse.x, mouse.y, player.x, player.y);	// send mouse and player coordination for scroll background
				}
				// reset map image and player coordination on restart map
				if (gameOver && !gameOver_delay && !game_end){								
					gameOver_delay = true; // set flag for make a delay for loading images
					// set new map level
					map_level_buffer = Math.floor(Math.random() * 3);
					if (map_level_buffer == map_level){
						map_level++;
						if (map_level > 2) map_level = 0;
					}else{
						map_level = map_level_buffer;
					}
					_gaq.push(['_trackEvent', 'Tablet Mini Game', 'Stop', 'Road Block' ]);
					//map_level++;
					//if (map_level > 2) map_level = 0;
					
					// reset classes
					backGRmanager.reset(fileNames.getData("map", map_stage, map_level));	
					pathFinder.reset(keyMap.getData(map_stage, map_level));
					player.setplayerStartPoint(pathFinder.playerStartCoord_x, pathFinder.playerStartCoord_y);
					addGameStartDelay();
				}
				
			}, false);
			/////////////////////////////////////////// touch
			canvas.addEventListener('touchstart',  function () {
					player_Xbuffer_touch = touch.x;
					player_Ybuffer_touch = touch.y;
					
					player.setDestination(player_Xbuffer_touch, player_Ybuffer_touch);																		// send mouse coodination to player class
					backGRmanager.setDestination(player_Xbuffer_touch, player_Ybuffer_touch, player.x, player.y);	// send mouse and player coordination for scroll background
			}, false);
			// restart 
			function restartGame(){
				startGame = false;
				gameOver = true;
			}
			// delay on new game 
			function addGameStartDelay(){
				// delay for .1 ms 
				setTimeout(function(){
					//alert("Hello");
					gameOver = false;
					gameOver_delay = false;
					game_nextLevel = false;
				},1000);
			}
			// next level
			function checkNextLevel(){
				map_stage++; // increase level difficulty 
				startGame = false;
				gameOver = true;
				if (map_stage < 3){
					game_nextLevel = true;
					var gameSpeed = gameSpeed_def[gameSpeed_iterator++]; // increase game speed
					_gaq.push(['_trackEvent', 'Tablet Mini Game', 'Play', 'Road Block' ]);
				}else{
					_gaq.push(['_trackEvent', 'Tablet Mini Game', 'Finish', 'Road Block' ]);
					game_end = true;
				}
			}
			// drawing 
			(function drawFrame () {
				window.requestAnimationFrame(drawFrame, canvas);
				context.clearRect(0, 0, canvas.width, canvas.height);
					// render BKGR
					backGRmanager.draw(context, 0, 0, startGame, !gameOver);	
					//if ( touch.isPressed ){
						//context.fillText(pathFinder.endPath + " || " +  gameOver_delay + "  |||  ", 10, 50); 			// test message
						//if (isTouch) context.fillText(" >> touch screen device detected. ", 10, 50); 			// test message
					//}
					// -------- check path finder`s path (test only) -----
					if (false){ // change to true/false
						context.beginPath();
						for (var i = 0; i < pathFinder.mapCoord_guid.length; i++){
							if ( pathFinder.mapCoord_guid[i] == "1" || pathFinder.mapCoord_guid[i] == "2") context.rect(pathFinder.mapCoord_rect[i].x, pathFinder.mapCoord_rect[i].y, pathFinder.mapCoord_rect[i].w, pathFinder.mapCoord_rect[i].h);
						}
						// text decoration for test messages
						context.fillStyle = 'orange';
						context.fill();
						context.lineWidth = 0;
						context.strokeStyle = 'white';
						context.stroke();
					}
					// ---------------------------------------------------
					
					// check for player movement
					if (startGame && !gameOver){
					//if (startGame){
						pathFinder.shiftPath(backGRmanager.speed);														// shift path with background speed
						if (pathFinder.checkEndLevel(player.x + 38, player.y + 38, context)){
							checkNextLevel();
						}else{
						
							if (pathFinder.checkCoordinat(player.x + 38, player.y + 38, context)) {		// check player coordinations 
							//if (true) {		// check player coordinations 
									// if player is inside the path , buffer "current" coordinations and move the player
									player_Xbuffer = player.x;																						
									player_Ybuffer = player.y;
									player.moveit(context);
							}else{
								// if player is NOT inside the path , back player to buffered coordination 
								player.x = player_Xbuffer;
								player.y = player_Ybuffer;
								player.stopMove(context);																									// stop player move
								if (!pathFinder.endPath) player.move_withBKGR(context);						// lock player on background with same speed
							}
							
						}
						// check if player reach to destination, then lock player on background with same speed
						if (player.moveInProgress == false && !pathFinder.endPath)		player.move_withBKGR(context);
						
						// render player
						player.draw(context);
						//context.fillText(backGRmanager.map_images[0].x + " || " +  Math.round(player.y), mouse.x, 440); 			// test message
					}
					// game over
					if (player.x < 0){
						restartGame();
					}
					// start game
					if (startGame == false && gameOver == false){ // render start message
						msg.draw(context, "start");
					}
					// game over message
					if (gameOver && !game_nextLevel && !game_end){
						msg.draw(context, "over");
					}
					// game next level message
					if (game_nextLevel){
						msg.draw(context, "next");
					}
					// game end message
					if (game_end){
						msg.draw(context, "end");
					}
					
					
			}());
			};